﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using _3dstate;
using Math3D;

namespace Tank
{
    public partial class Tank : Form
    {
        //double m_tank_climb_ability = 1000;
        
        void move_tank()
        {
            double[] current_location = new double[3];
            _3D.STATE_object_get_location1(m_tank_object, current_location);

            double[] direction = new double[3];
            _3D.STATE_object_get_direction1(m_tank_object, direction);

            double[] step = Vector.copy(direction);
            Vector.mul_vec(step, m_tank_speed);

            double[] wanted_location = Vector.copy(current_location);
            Vector.add_vec(wanted_location, step);

            _3D.STATE_object_set_location(m_tank_object, wanted_location[0], wanted_location[1],1e10);

            _3D.STATE_object_drop_down_fast(m_tank_object, m_tank_height, _3D.YES, _3D.YES);

            /*
            _3D.STATE_object_move(m_tank_object, _3D.WORLD_SPACE, 0, 0, 1e6);
            double min_height, max_height;
            _3D.STATE_object_get_bounding_box_height_above_ground(m_tank_object, _3D.YES, out min_height, out max_height);
            _3D.STATE_object_move(m_tank_object, _3D.WORLD_SPACE, 0, 0, -min_height);
            */


            turn_tank_according_to_keyboard_input(m_tank_object);

            m_tank_speed = change_speed_according_to_keyboard_input(m_tank_speed, m_ariel18);

            check_that_the_tank_doesnt_go_out_of_the_terrain();


            check_that_the_camera_doesnt_go_under_the_ground();

        }
/*
        bool drop_tank_down()
        {
            double min_height, max_height;
            uint poly=_3D.STATE_object_get_bounding_box_height_above_ground(m_tank_object, _3D.YES, out min_height, out max_height);
            if (poly == 0)
                return (false);
            
            _3D.STATE_object_move(m_tank_object, _3D.WORLD_SPACE, 0, 0, -min_height);
            return (true);
            



        }
*/
        double get_terrain_height_at_location(double[] location)
        {
            double[] above = Vector.copy(location);
            above[2] = 1e10;

            double[] below = Vector.copy(location);
            below[2] = -1e10;

            _3D.STATE_engine_ignore_dynamic_objects_for_collision_detection(_3D.YES);

            double[] intersection = new double[3];
            uint polygon, obj;
            _3D.STATE_engine_is_movement_possible(above, below, out polygon, intersection, out obj);

            _3D.STATE_engine_ignore_dynamic_objects_for_collision_detection(_3D.NO);

            return (intersection[2]);


        }
    
    }
}